<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.14"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>iipsrv: Memcached.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
  $(document).ready(initResizable);
/* @license-end */</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="iip.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">iipsrv
   &#160;<span id="projectnumber">1.1</span>
   </div>
   <div id="projectbrief">iipsrv is an advanced high-performance feature-rich image server for web-based streamed viewing and zooming of ultra high-resolution images</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.14 -->
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',false,false,'search.php','Search');
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('Memcached_8h_source.html','');});
/* @license-end */
</script>
<div id="doc-content">
<div class="header">
  <div class="headertitle">
<div class="title">Memcached.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">// Simple Wrapper to libMemcached</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;</div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment">/*  IIP Image Server</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"></span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment">    Copyright (C) 2010-2013 Ruven Pillay.</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"></span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment">    This program is free software; you can redistribute it and/or modify</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment">    it under the terms of the GNU General Public License as published by</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment">    the Free Software Foundation; either version 3 of the License, or</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment">    (at your option) any later version.</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"></span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment">    This program is distributed in the hope that it will be useful,</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment">    GNU General Public License for more details.</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment"></span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment">    You should have received a copy of the GNU General Public License</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment">    along with this program; if not, write to the Free Software Foundation,</span></div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment">    Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment">*/</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;</div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;</div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;</div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="preprocessor">#ifndef _MEMCACHED_H</span></div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="preprocessor">#define _MEMCACHED_H</span></div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="preprocessor">#include &lt;string&gt;</span></div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="preprocessor">#include &lt;libmemcached/memcached.h&gt;</span></div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="preprocessor">#ifdef LIBMEMCACHED_VERSION_STRING</span></div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="keyword">typedef</span> memcached_return memcached_return_t;</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;</div><div class="line"><a name="l00036"></a><span class="lineno"><a class="line" href="classMemcache.html">   36</a></span>&#160;<span class="keyword">class </span><a class="code" href="classMemcache.html">Memcache</a> {</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160; <span class="keyword">private</span>:</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;  memcached_st *_memc;</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;  memcached_return_t _rc;</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;  memcached_server_st *_servers;</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;  time_t _timeout;</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160; </div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;  <span class="keywordtype">size_t</span> _length;</div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;  <span class="keywordtype">bool</span> _connected;</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160; <span class="keyword">public</span>:</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;</div><div class="line"><a name="l00066"></a><span class="lineno"><a class="line" href="classMemcache.html#a3c22bb888cc80ebc2b4012f0f737b01a">   66</a></span>&#160;  <a class="code" href="classMemcache.html#a3c22bb888cc80ebc2b4012f0f737b01a">Memcache</a>( <span class="keyword">const</span> std::string&amp; servernames = <span class="stringliteral">&quot;localhost&quot;</span>, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> timeout = 3600 ) {</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;    _length = 0;</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;    <span class="comment">// Set our timeout</span></div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;    _timeout =  timeout;</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;    <span class="comment">// Create our memcached object</span></div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;    _memc = memcached_create(NULL);</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;    <span class="comment">// Create a list of servers</span></div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;    _servers = memcached_servers_parse( servernames.c_str() );</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;    <span class="comment">// Try to set some memcached behaviour settings for performance. For example,</span></div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;    <span class="comment">// using the binary protocol, non-blocking IO, and no reply for add commands</span></div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;    _rc =  memcached_behavior_set( _memc, MEMCACHED_BEHAVIOR_BINARY_PROTOCOL, 1 );</div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;    _rc =  memcached_behavior_set( _memc, MEMCACHED_BEHAVIOR_NO_BLOCK, 1 );</div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;    _rc =  memcached_behavior_set( _memc, MEMCACHED_BEHAVIOR_TCP_NODELAY, 1 );</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;    _rc =  memcached_behavior_set( _memc, MEMCACHED_BEHAVIOR_NOREPLY, 1 );</div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;</div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;    <span class="comment">// Connect to the servers</span></div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;    _rc = memcached_server_push( _memc, _servers );</div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;    <span class="keywordflow">if</span>(_rc == MEMCACHED_SUCCESS ) _connected = <span class="keyword">true</span>;</div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;    <span class="keywordflow">else</span> _connected = <span class="keyword">false</span>;</div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;</div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;    <span class="keywordflow">if</span>( memcached_server_count(_memc) &gt; 0 ) _connected = <span class="keyword">true</span>;</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;    <span class="keywordflow">else</span> _connected = <span class="keyword">false</span>;</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;  };</div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;</div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;</div><div class="line"><a name="l00097"></a><span class="lineno"><a class="line" href="classMemcache.html#a5e0ab8c7eb4e6f7bf521d04878263af6">   97</a></span>&#160;  <a class="code" href="classMemcache.html#a5e0ab8c7eb4e6f7bf521d04878263af6">~Memcache</a>() {</div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;    <span class="comment">// Disconnect from our servers and free our memcached structure</span></div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;    <span class="keywordflow">if</span>( _servers ) memcached_server_free(_servers); </div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;    <span class="keywordflow">if</span>( _memc ) memcached_free(_memc);</div><div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;  }</div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;</div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;</div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;</div><div class="line"><a name="l00109"></a><span class="lineno"><a class="line" href="classMemcache.html#a0412e512f048add9f3aa43f32e79d81e">  109</a></span>&#160;  <span class="keywordtype">void</span> <a class="code" href="classMemcache.html#a0412e512f048add9f3aa43f32e79d81e">store</a>( <span class="keyword">const</span> std::string&amp; key, <span class="keywordtype">void</span>* data, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classMemcache.html#af58dc0143ee46382a2b382175f3c44c6">length</a> ){</div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;</div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;    <span class="keywordflow">if</span>( !_connected ) <span class="keywordflow">return</span>;</div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160; </div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;    std::string k = <span class="stringliteral">&quot;iipsrv::&quot;</span> + key;</div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;    _rc = memcached_set( _memc, k.c_str(), k.length(),</div><div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;                        (<span class="keywordtype">char</span>*) data, <a class="code" href="classMemcache.html#af58dc0143ee46382a2b382175f3c44c6">length</a>,</div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;                        _timeout, 0 );</div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;  }</div><div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;</div><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;</div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;</div><div class="line"><a name="l00124"></a><span class="lineno"><a class="line" href="classMemcache.html#a3b6aadc6bbad03eac85883d33b286e6e">  124</a></span>&#160;  <span class="keywordtype">char</span>* <a class="code" href="classMemcache.html#a3b6aadc6bbad03eac85883d33b286e6e">retrieve</a>( <span class="keyword">const</span> std::string&amp; key ){</div><div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;</div><div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;    <span class="keywordflow">if</span>( !_connected ) <span class="keywordflow">return</span> NULL;</div><div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;</div><div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;    uint32_t flags;</div><div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;    std::string k = <span class="stringliteral">&quot;iipsrv::&quot;</span> + key;</div><div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;    <span class="keywordflow">return</span> memcached_get( _memc, k.c_str(), k.length(), &amp;_length, &amp;flags, &amp;_rc );</div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;  }</div><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;</div><div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;</div><div class="line"><a name="l00135"></a><span class="lineno"><a class="line" href="classMemcache.html#aa8da4e3bf1267e4eab87812ed6a3a161">  135</a></span>&#160;  <span class="keyword">const</span> <span class="keywordtype">char</span>* <a class="code" href="classMemcache.html#aa8da4e3bf1267e4eab87812ed6a3a161">error</a>(){</div><div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;    <span class="keywordflow">return</span> memcached_strerror( _memc, _rc );</div><div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;  };</div><div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;</div><div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;</div><div class="line"><a name="l00141"></a><span class="lineno"><a class="line" href="classMemcache.html#af58dc0143ee46382a2b382175f3c44c6">  141</a></span>&#160;  <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classMemcache.html#af58dc0143ee46382a2b382175f3c44c6">length</a>(){ <span class="keywordflow">return</span> _length; };</div><div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;</div><div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;</div><div class="line"><a name="l00145"></a><span class="lineno"><a class="line" href="classMemcache.html#a10538d2b21f6b74c921f3066610d7d45">  145</a></span>&#160;  <span class="keywordtype">bool</span> <a class="code" href="classMemcache.html#a10538d2b21f6b74c921f3066610d7d45">connected</a>(){ <span class="keywordflow">return</span> _connected; };</div><div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;</div><div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;</div><div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;};</div><div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;</div><div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;</div><div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;</div><div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;<span class="preprocessor">#endif</span></div><div class="ttc" id="classMemcache_html_a3b6aadc6bbad03eac85883d33b286e6e"><div class="ttname"><a href="classMemcache.html#a3b6aadc6bbad03eac85883d33b286e6e">Memcache::retrieve</a></div><div class="ttdeci">char * retrieve(const std::string &amp;key)</div><div class="ttdoc">Retrieve data from our cache. </div><div class="ttdef"><b>Definition:</b> Memcached.h:124</div></div>
<div class="ttc" id="classMemcache_html_a3c22bb888cc80ebc2b4012f0f737b01a"><div class="ttname"><a href="classMemcache.html#a3c22bb888cc80ebc2b4012f0f737b01a">Memcache::Memcache</a></div><div class="ttdeci">Memcache(const std::string &amp;servernames=&quot;localhost&quot;, unsigned int timeout=3600)</div><div class="ttdoc">Constructor. </div><div class="ttdef"><b>Definition:</b> Memcached.h:66</div></div>
<div class="ttc" id="classMemcache_html"><div class="ttname"><a href="classMemcache.html">Memcache</a></div><div class="ttdoc">Cache to store raw tile data. </div><div class="ttdef"><b>Definition:</b> Memcached.h:36</div></div>
<div class="ttc" id="classMemcache_html_a0412e512f048add9f3aa43f32e79d81e"><div class="ttname"><a href="classMemcache.html#a0412e512f048add9f3aa43f32e79d81e">Memcache::store</a></div><div class="ttdeci">void store(const std::string &amp;key, void *data, unsigned int length)</div><div class="ttdoc">Insert data into our cache. </div><div class="ttdef"><b>Definition:</b> Memcached.h:109</div></div>
<div class="ttc" id="classMemcache_html_aa8da4e3bf1267e4eab87812ed6a3a161"><div class="ttname"><a href="classMemcache.html#aa8da4e3bf1267e4eab87812ed6a3a161">Memcache::error</a></div><div class="ttdeci">const char * error()</div><div class="ttdoc">Get error string. </div><div class="ttdef"><b>Definition:</b> Memcached.h:135</div></div>
<div class="ttc" id="classMemcache_html_a10538d2b21f6b74c921f3066610d7d45"><div class="ttname"><a href="classMemcache.html#a10538d2b21f6b74c921f3066610d7d45">Memcache::connected</a></div><div class="ttdeci">bool connected()</div><div class="ttdoc">Tell us whether we are connected to any memcached servers. </div><div class="ttdef"><b>Definition:</b> Memcached.h:145</div></div>
<div class="ttc" id="classMemcache_html_af58dc0143ee46382a2b382175f3c44c6"><div class="ttname"><a href="classMemcache.html#af58dc0143ee46382a2b382175f3c44c6">Memcache::length</a></div><div class="ttdeci">unsigned int length()</div><div class="ttdoc">Return the number of bytes in the result. </div><div class="ttdef"><b>Definition:</b> Memcached.h:141</div></div>
<div class="ttc" id="classMemcache_html_a5e0ab8c7eb4e6f7bf521d04878263af6"><div class="ttname"><a href="classMemcache.html#a5e0ab8c7eb4e6f7bf521d04878263af6">Memcache::~Memcache</a></div><div class="ttdeci">~Memcache()</div><div class="ttdoc">Destructor. </div><div class="ttdef"><b>Definition:</b> Memcached.h:97</div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><b>Memcached.h</b></li>
    <li class="footer">Generated by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.14 </li>
  </ul>
</div>
</body>
</html>
